/**
 * @file
 * @brief CRC-8-CCITT algorithm.
 */
/*
 * $LastChangedRevision: 1273 $
 * $LastChangedDate:: 2017-09-28 15:07:29 +0200#$
 *
 * This file is part of X2C. http://www.mechatronic-simulation.org/
 *
 * Copyright (c) 2013, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
 * All rights reserved.
 */
#ifndef CRC8CCITT_H
#define CRC8CCITT_H

#ifdef __cplusplus
extern "C" {
#endif

#include "Target.h"

/* public prototypes */
uint8 crc8ccitt(const uint8* data, uint32 size);
uint8 crc8ccitt_addValue(uint8 crc, uint8 data);
uint8 crc8ccitt_init(void);

#ifdef __cplusplus
}
#endif

#endif
